set F=%sd_tmp%/Magisk.zip

adb shell ls %sd_tmp% >nul 2>nul || (
    echo - 该功能会向手机目录%sd_tmp%，发送文件是否愿意？
    echo - 0.回到主菜单     回车和任意内容继续
    echo. 
    echo.
    set gn=
    set /p gn=%t2%
    if "!gn!"=="0" ( main )
    adb shell mkdir -p %sd_tmp%
    adb shell touch %sd_tmp%/警告不要在这里存放文件.log
    echo.
)


:m
echo - 1.自定义Magisk版本刷入    回车和任意内容为采用内置的Magisk-23.0.zip

set gn=
echo.
echo.
set /p gn=%t2%
if "!gn!"=="1" ( goto file ) else (
    set Customizeapk=false
)

if exist %magisk_file% ( goto Brush_in ) else (
    %error% 文件不存在
    goto m
)


:file
    %tishi1% 刷入的Magisk.zip
    set magisk_file=
    set /p magisk_file=%t1%
    if not defined magisk_file ( %error% 未选择文件，刷个鸡儿 & goto file )
    if not exist %magisk_file% ( %error% 选择的文件不存在，刷个鸡儿 & goto file )
    set Customizeapk=true


:Brush_in
    echo - 请选择您的设备状态
    echo.
    set gn=
    echo - 1.rec/TWRP模式下        2.系统/ADB Sideload模式下        3.FASTBOOT模式下
    echo.
    echo.
    set /p gn=%t2%
    if "!gn!"=="1" ( goto lebal )
    
    echo - 如果无法自动重启到rec/TWRP模式请手动进入
    if "!gn!"=="2" (
        echo - 开始重启到rec/TWRP
        call bat\a4.bat
        goto lebal
    )
    
    if "!gn!"=="3" (
        set gn=
        echo - 3.使用方法①进入       4.使用方法②进入
        echo.
        echo.
        set /p gn=%t2%
        if "!gn!"=="4" ( call bat\f4.bat ) else ( call bat\f3.bat )
        goto lebal
    )
        goto Brush_in


:lebal
            %awfr%
            echo - 发送%magisk_file%到%F%
            adb shell rm -rf %F% >nul 2>nul
            adb push %magisk_file% %F%
            adb shell ls %F%
            if not "%errorlevel%"=="0" (
                %error% 发送失败
                %error% 请确保您的设备data已解密或没有强制加密
                echo.
                %error% 解决办法1：
                %error% 在系统开机状态下移除锁屏密码即可
                echo.
                %error% 解决办法2：
                %error% 刷个可以解密data的rec/TWRP，绘制锁屏密码进入rec/TWRP主页即可
                abort
            )
                echo - 开始安装：%F%……
                echo - 等待设备刷入完毕……
                adb shell twrp install %F%
                if "%errorlevel%"=="0" ( echo - %F%刷入完毕 ) else ( abort %F%刷入失败，请确保对方设备使用的是三方recovery )
    
                set gn=
                echo - 您的设备是否是联发科设备？
                echo - 可去recovery里禁用AVB2.0的启动校验和DM校验否则会无法开机，当然有的高通机型也有可能需要禁用(小米高通机型不用此操作请跳过)
                %CQ%
                if not "!gn!"=="1" ( goto end )
    
                    busybox %Customizeapk% || (
                        set gn=
                        echo - 是否现在安装%magisk_vn%？
                        echo.
                        echo.
                        set /p gn=输入1为确定安装     回车或任意内容为跳过：
                        if "!gn!"=="1" (
                            %awfd%
                            echo - 请确保手机已进入系统，部分系统需要在手机上确定才能安装
                            adb install -r %magisk_file%
                            echo.
                            echo - 如果上面这行出现了 Success 就说明安装成功了
                        )
                    )


:end
    abort
